#ifndef _MATRIXVBZ_H_
#define _MATRIXVBZ_H_


// Hilfsprogramme 
#include <iostream>
using namespace std;
#include <cstdlib>

void LengthVBZfromCSR(int* column_indices,int* row_offsets,
                                        int n,int *m)
// Input: nxn Matrix in CSR-Format
// Output: m Laenge eines Feldes, wenn in VBZ-Format gespeichert
{
  int i,k1,k2,j1,j2;
  *m=0;
  j2=0;
  for  (i=0;i<n;i++)
    {
      k1=row_offsets[i];  
      j1=column_indices[k1];  // kleinster Index Zeile i
      k2=row_offsets[i+1];
      j2=max(j2,column_indices[k2-1]); // groesster Index Zeile i 
      // Bei wieder einrueckenden Baendern Vorsicht!
      *m+=j2-j1+1;
    }
}

void TransformCSRtoVBZ(int* CSRcolumn_indices,double* CSRentries,
		       int* CSRrow_offsets,int n,int m,int ncsr,
		       int* VBZcolumn_indices,double* VBZentries,
                       int* VBZrow_offsets, int*  VBZrow_indices)
// Input: nxn Matrix in CSR-Format
// Output: m Laenge eines Feldes, wenn in VBZ-Format gespeichert
{
  int i,k1,k2,j1,j,k,mv,j2;
  double z[1];
  z[0]=0;
  vdcopy(m,VBZentries,1,z,0); // alles mit 0 fuellen
  mv=0;
  j2=0;
  for  (i=0;i<n;i++)
    {
      VBZrow_offsets[i]=mv;
      k1=CSRrow_offsets[i];  
      VBZcolumn_indices[i]=CSRcolumn_indices[k1];  // kleinster Index Zeile i
      j1= VBZcolumn_indices[i];
      k2= CSRrow_offsets[i+1];
      j2= max(CSRcolumn_indices[k2-1],j2);
      for (k=k1;k<k2;k++)
        {
         j=CSRcolumn_indices[k];
         VBZentries[j-j1+mv]=CSRentries[k]; //NNE setzen  
         VBZrow_indices[j]=i;   
        } 
      mv=mv+j2-j1+1;
      
    }
   VBZrow_offsets[i]=mv;
   for  (i=n-1;i>-1;i--)
     {
      j=VBZcolumn_indices[i]; 
      for (j1=j;j1<i;j1++)
	{
	  VBZrow_indices[j1]=max(i,VBZrow_indices[j1]);  
        } 
     }

}


void MatVecMulVBZ(int* column_indices,double* entries,
          int* row_offsets,double* x, double* y,int n)
// Matrix Vektormultiplikation 
{
  int i,k1,k2,j;
  double z[1]; 
  z[0]=0;
  vdcopy(n,y,1,z,0);
  for (i=0;i<n;i++)
    {
      k1=row_offsets[i];
      k2=row_offsets[i+1];
      j=column_indices[i];
      dscapr(&y[i],k2-k1,&x[j],&entries[k1]);   
    }
}

void GenDiagVBZ(int* column_indices,double* entries,
          int* row_offsets,double* D,int n)
// Berechnet fuer VBZ-Matrix die Hauptdiagonale D
// Annahme: HD geheort stets zum Block mit dazu.
{
  int i,j,k;
 for (i=0;i<n;i++)
   {
     k=row_offsets[i];
     j=column_indices[i]; 
     D[i]=entries[k+i-j];
   } 

}



#endif
